
/// Custom tags.
library tags.custom;

import 'dart:async';
import 'dart:html';
import 'builder.dart';
import 'html.dart';

part 'custom/toggle_button.dart';
part 'custom/toggle_open.dart';

/// A function to bind to a custom element's [model].
///
/// Warning: once we are allowed to extend Element this is likely to be removed.
typedef void BindModel(HasElement model);

final Tag toggleOpen = ([BuildChildren b, BindModel onBind]) => 
    buildNode(() => bindModel(new ToggleOpen(), onBind), b);

final Tag toggleButton = ([BuildChildren b, BindModel onBind]) => 
    buildNode(() => bindModel(new ToggleButton(), onBind), b);

/// Call [onBind] with the given [model] and return the model's element.
Element bindModel(HasElement model, BindModel onBind) {
  if (onBind != null) onBind(model);
  return model.element;
}

/// An object that has an element.
///
/// Warning: once we are allowed to extend Element this is likely to be removed.
abstract class HasElement {
  Element get element;
}
