
/// Html tags.
library tags.html;

import 'dart:html';
import 'builder.dart';

final Tag a         = ([BuildChildren b, _]) => 
                      buildNode(() => new AnchorElement(), b);
final Tag area      = ([BuildChildren b, _]) => 
                      buildNode(() => new AreaElement(), b);
final Tag b         = ([BuildChildren b_, _]) => 
                      buildNode(() => _element('b'), b_);
final Tag base      = ([BuildChildren b, _]) => 
                      buildNode(() => new BaseElement(), b);
final Tag body      = ([BuildChildren b, _]) => 
                      buildNode(() => new BodyElement(), b);
final Tag br        = ([BuildChildren b, _]) => 
                      buildNode(() => new BRElement(), b);
final Tag button    = ([BuildChildren b, _]) => 
                      buildNode(() => new ButtonElement(), b);
final Tag canvas    = ([BuildChildren b, _]) => 
                      buildNode(() => new CanvasElement(), b);
final Tag caption   = ([BuildChildren b,_]) =>
                      buildNode(() => new TableCaptionElement(),b);
final Tag col       = ([BuildChildren b, _]) => 
                      buildNode(() => new TableColElement(), b);
final Tag content   = ([BuildChildren b, _]) => 
                      buildNode(() => new ContentElement(), b);
final Tag datalist  = ([BuildChildren b, _]) => 
                      buildNode(() => new DataListElement(), b);
final Tag dd        = ([BuildChildren b, _]) => 
                      buildNode(() => _element('dd'), b);
final Tag del       = ([BuildChildren b, _]) => 
                      buildNode(() => _element('del'), b);
final Tag details   = ([BuildChildren b, _]) => 
                      buildNode(() => new DetailsElement(), b);
final Tag div       = ([BuildChildren b, _]) => 
                      buildNode(() => new DivElement(), b);
final Tag dl        = ([BuildChildren b, _]) => 
                      buildNode(() => _element('dl'), b);
final Tag dt        = ([BuildChildren b, _]) => 
                      buildNode(() => _element('dt'), b);
final Tag embed     = ([BuildChildren b, _]) => 
                      buildNode(() => new EmbedElement(), b);
final Tag fieldset  = ([BuildChildren b, _]) => 
                      buildNode(() => new FieldSetElement(), b);
final Tag form      = ([BuildChildren b, _]) => 
                      buildNode(() => new FormElement(), b);
final Tag h1        = ([BuildChildren b, _]) => 
                      buildNode(() => new HeadingElement.h1(), b);
final Tag h2        = ([BuildChildren b, _]) => 
                      buildNode(() => new HeadingElement.h2(), b);
final Tag h3        = ([BuildChildren b, _]) => 
                      buildNode(() => new HeadingElement.h3(), b);
final Tag h4        = ([BuildChildren b, _]) => 
                      buildNode(() => new HeadingElement.h4(), b);
final Tag h5        = ([BuildChildren b, _]) => 
                      buildNode(() => new HeadingElement.h5(), b);
final Tag h6        = ([BuildChildren b, _]) => 
                      buildNode(() => new HeadingElement.h6(), b);
final Tag head      = ([BuildChildren b, _]) => 
                      buildNode(() => new HeadElement(), b);
final Tag hr        = ([BuildChildren b, _]) => 
                      buildNode(() => new HRElement(), b);
final Tag html      = ([BuildChildren b, _]) => 
                      buildNode(() => new HtmlHtmlElement(), b);
final Tag i         = ([BuildChildren b, _]) => 
                      buildNode(() => _element('i'), b);
final Tag img       = ([BuildChildren b, _]) => 
                      buildNode(() => new ImageElement(), b);
final Tag input     = ([BuildChildren b, _]) => 
                      buildNode(() => new InputElement(), b);
final Tag keygen    = ([BuildChildren b, _]) => 
                      buildNode(() => new KeygenElement(), b);
final Tag label     = ([BuildChildren b, _]) => 
                      buildNode(() => new LabelElement(), b);
final Tag legend    = ([BuildChildren b, _]) => 
                      buildNode(() => new LegendElement(), b);
final Tag li        = ([BuildChildren b, _]) => 
                      buildNode(() => new LIElement(), b);
final Tag link      = ([BuildChildren b, _]) => 
                      buildNode(() => new LinkElement(), b);
final Tag map       = ([BuildChildren b, _]) => 
                      buildNode(() => new MapElement(), b);
final Tag menu      = ([BuildChildren b, _]) => 
                      buildNode(() => new MenuElement(), b);
final Tag meter     = ([BuildChildren b, _]) => 
                      buildNode(() => new MeterElement(), b);
final Tag nav       = ([BuildChildren b, _]) => 
                      buildNode(() => _element('nav'), b);
final Tag object    = ([BuildChildren b, _]) => 
                      buildNode(() => new ObjectElement(), b);
final Tag ol        = ([BuildChildren b, _]) => 
                      buildNode(() => new OListElement(), b);
final Tag optgroup  = ([BuildChildren b, _]) => 
                      buildNode(() => new OptGroupElement(), b);
final Tag option    = ([BuildChildren b, _]) => 
                      buildNode(() => new OptionElement(), b);
final Tag output    = ([BuildChildren b, _]) => 
                      buildNode(() => new OutputElement(), b);
final Tag p         = ([BuildChildren b, _]) => 
                      buildNode(() => new ParagraphElement(), b);
final Tag param     = ([BuildChildren b, _]) => 
                      buildNode(() => new ParamElement(), b);
final Tag pre       = ([BuildChildren b, _]) => 
                      buildNode(() => new PreElement(), b);
final Tag progress  = ([BuildChildren b, _]) => 
                      buildNode(() => new ProgressElement(), b);
final Tag script    = ([BuildChildren b, _]) => 
                      buildNode(() => new ScriptElement(), b);
final Tag select    = ([BuildChildren b, _]) => 
                      buildNode(() => new SelectElement(), b);
final Tag source    = ([BuildChildren b, _]) => 
                      buildNode(() => new SourceElement(), b);
final Tag span      = ([BuildChildren b, _]) => 
                      buildNode(() => new SpanElement(), b);
final Tag style     = ([BuildChildren b, _]) => 
                      buildNode(() => new StyleElement(), b);
final Tag table     = ([BuildChildren b, _]) => 
                      buildNode(() => new TableElement(), b);
final Tag tbody     = ([BuildChildren b, _]) => 
                      buildNode(() => _element('tbody'), b);
final Tag td        = ([BuildChildren b, _]) => 
                      buildNode(() => new TableCellElement(), b);
final Tag template  = ([BuildChildren b, _]) => 
                      buildNode(() => _element('template'), b);
final Tag textarea  = ([BuildChildren b, _]) => 
                      buildNode(() => new TextAreaElement(), b);
final Tag tfoot     = ([BuildChildren b, _]) => 
                      buildNode(() => _element('tfoot'), b);
final Tag th        = ([BuildChildren b, _]) => 
                      buildNode(() => _element('th'), b);
final Tag thead     = ([BuildChildren b, _]) => 
                      buildNode(() => _element('thead'), b);
final Tag title     = ([BuildChildren b, _]) => 
                      buildNode(() => new TitleElement(), b);
final Tag tr        = ([BuildChildren b, _]) => 
                      buildNode(() => new TableRowElement(), b);
final Tag track     = ([BuildChildren b, _]) => 
                      buildNode(() => new TrackElement(), b);
final Tag u         = ([BuildChildren b, _]) => 
                      buildNode(() => _element('u'), b);
final Tag ul        = ([BuildChildren b, _]) => 
                      buildNode(() => new UListElement(), b);
final Tag video     = ([BuildChildren b, _]) => 
                      buildNode(() => new VideoElement(), b);

/// Append the given [node] to the current [buildHostNode].
///
/// An optional build function may be provided to build child elements.  This 
/// function provides a means to append existing elements in a tag builder 
/// expression.
Node append(Node node, [BuildChildren b]) => buildNode(() => node, b);

/// Create a shadow root for the current [buildHostNode].
///
/// This function may only be called from inside a [BuildChildren] function and 
/// the host must be an element.
ShadowRoot shadow([BuildChildren b]) {
  final _host = buildHostNode;
  if (_host is! Element) {
    throw new StateError('shadow() may only be called if host is an Element.');
  }
  return buildNode(() => _host.createShadowRoot(), b);
}

/// Append the given [text] as a text node to the current [buildHostNode].
///
/// This function may only be called from inside a [BuildChildren] function and 
/// the [buildHostNode] must be an element.
void text(String text) {
  final _host = buildHostNode;
  if (_host is! Element) 
    throw new StateError('text() may only be called if host is an Element.');
  _host.appendText(text);
}

// Create an Element for a `tag` that is untyped in `dart:html`.  E.g. `<th>`
Element _element(String tag) {
  if (!Element.isTagSupported(tag)) throw new UnsupportedError(tag);
  return new Element.tag(tag);
}
